# -*- coding: utf-8 -*-

from collections import defaultdict

dups = {
	'Bart ter Haar Romenij': 'Bart ter Haar Romeny',
	'David Banks': 'David C. Banks',
	'Enylton Coalho': 'Enylton M. Coelho',
	'Heike Jaenicke': 'Heike Jänicke',
	'Heike Janicke': 'Heike Jänicke',
	'Jarke J. Van Wijk': 'Jarke J. van Wijk',
	'Marian Dork': 'Marian Dörk',
	'Nathalie Henry': 'Nathalie Henry Riche',
	'Nathalie Riche': 'Nathalie Henry Riche',
	'Nathalie y Henr': 'Nathalie Henry Riche',
	'P. -T. Bremer': 'Peer-Timo Bremer',
	'Robert M. Kirby': 'Robert Mike Kirby',
	'Sheelash Carpendale': 'Sheelagh Carpendale',
	"Meister Eduard Groller": "Eduard Gröller",
	"Eduard Groller": "Eduard Gröller",
	"Eduard Grøller": "Eduard Gröller",
	"M. Eduard Groller": "Eduard Gröller",
	"M. Eduard Gröller": "Eduard Gröller",

	'Alex Telea': 'Alexandru Telea',
	'Arie kaufman': 'Arie Kaufman',
	'Ben Watson': 'Benjamin Watson',
	'Cagatay Demiralp': 'Çağatay Demiralp',
	'Carlos Correa': 'Carlos D. Correa',
	'Carlos Scheidegger': 'Carlos E. Scheidegger',
	'Charl Botha': 'Charl P. Botha',
	'Charles Hansen': 'Charles D. Hansen',
	'Christof Rezk Salama': 'Christof Rezk-Salama',
	'Claes Lundstrom': 'Claes Lundström',
	'Claudio Silva': 'Cláudio T. Silva',
	'Claudio T. Silva': 'Cláudio T. Silva',
	'Cláudio Silva': 'Cláudio T. Silva',
	'Daniel Keim': 'Daniel A. Keim',
	'David Ebert': 'David S. Ebert',
	'David Laidlaw': 'David H. Laidlaw',
	'David Krum': 'David M. Krum',
	'Deborah Silver': 'Debora Silver',
	'Desney Tan': 'Desney S. Tan',
	'Donald House': 'Donald H. House',
	'Doug Bowman': 'Doug A. Bowman',
	'Ezekiel Bhasker': 'Ezekiel S. Bhasker',
	'Fernanda B. Viegas': 'Fernanda B. Viégas',
	'Fernando Paulovich': 'Fernando V. Paulovich',
	'Frits Post': 'Frits H. Post',
	'Gordon Kindlmann': 'Gordon L. Kindlmann',
	'Javier Olivan Bescos': 'Javier Oliván Bescós',
	'Jens Kruger': 'Jens Krüger',
	'Jesus Caban': 'Jesus J. Caban',
	'John Anderson': 'John C. Anderson',
	'John Schreiner': 'John M. Schreiner',
	'Jurgen Waser': 'Jürgen Waser',
	'Kai Burger': 'Kai Bürger',
	'Katja Buhler': 'Katja Bühler',
	'Kenneth Joy': 'Kenneth I. Joy',
	'Luis G. Nonato': 'Luis Gustavo Nonato',
	'Luke Gosink': 'Luke J. Gosink',
	'Michael Bottinger': 'Michael Böttinger',
	'Phil Amburn': 'Philip Amburn',
	'Ross Whitaker': 'Ross T. Whitaker',
	'Rudiger Westermann': 'Rüdiger Westermann',
	'Stephen North': 'Stephen C. North',
	'Sung-eui Yoon': 'Sung-Eui Yoon',
	'V. Pascucci': 'Valerio Pascucci',

}

authors = defaultdict(set)
for line in open('authors.txt'):
	author_id, author_name = line.strip().split(None, 1)
	try:
		author_name = dups[author_name]
	except KeyError:
		pass
	authors[author_name].add(author_id)

for name in authors:
	ids = list(authors[name])
	i0 = ids[0]
	for i in ids:
		print i, i0, name

	