#! /usr/bin/env python3
# -*- coding: utf-8 -*-

# imports ####################################################################

import sys
import json
import os
import codecs

from collections import defaultdict


# data #######################################################################

path = os.path.join(os.path.dirname(sys.argv[0]), "pistou", "2013-12-11")
authors = json.load(open(os.path.join(path, "perms.json")))
publications = json.load(open(os.path.join(path, "lig.json")))["publications"]
dups = json.load(open(os.path.join(path, "dups.js")))

def name(author_dict):
	name = u" ".join(author_dict[k] for k in ["nom", "prenom"])
	name = dups.get(name, name)
	return name

perms = list(authors)
scores = defaultdict(int)
names = set()

for publication in publications:
#	if publication["x_international_audience"] != "yes":
#		continue
	coauthors = publication["auteurs"]
	coauthors = list(name(a) for a in coauthors)
	for i in coauthors:
		names.add(i)
		if i not in perms:
			continue
		for j in coauthors:
			scores[i, j] += 1
names = list(names)

for perm in perms:
	vector = list(float(scores[perm, name]) for name in names)
	if sum(list(u > 0 for u in vector)) <= 3.:
		continue
	print("%s [%s]" % (codecs.encode(perm, "rot_13"), ".".join(authors[perm])), *vector, sep="\t")
