# -*- coding: utf-8 -*-

from urllib2 import urlopen, HTTPError
from BeautifulSoup import BeautifulSoup
from time import strptime
from collections import defaultdict

TEAM = "https://pistou.imag.fr/teams/show/%s"
MAX_TEAM = 40

authors_teams = defaultdict(set)

for team_number in range(MAX_TEAM):
	try:
		html = urlopen(TEAM % team_number).read()
	except HTTPError:
		continue
	soup = BeautifulSoup(html)
	
	h1 = soup.find("h1")
	team = h1.text
	assert team.startswith("Equipe ")
	team = team[len("Equipe "):]
	print team
	
	authors = soup.find(id="entry-list")
	for td in authors.table.findAll("td"):
		name, date = td.findAll("span")
		name = name.string
		if date.string.endswith("2099"):
			authors_teams[name].add(team)		
	
import json
class SetEncoder(json.JSONEncoder):
	def default(self, obj):
		if isinstance(obj, set):
			return list(obj)
		return json.JSONEncoder.default(self, obj)

print json.dumps(authors_teams, cls=SetEncoder)
